/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller                                   *
 *   jkeller@imperial.ac.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __METHODS_H__
#define __METHODS_H__ 
#include "MMatrix.h" //library to handle matrices in memory quickly
#include "Sections.h"
#include "m_matrix2.h"
#include "Curvatures.h"
///#include "calabiyau.h"
  //in order to get the struct data_in 
  // TODO should remove structures in another places
#define Complex  std::complex<double>



double launch_method_pointwise_1a(const int Number_Points,const double ERR,const int Einstein,const int step,const Complex Psi,int method_refined,const int K,Data_in & Data, double error_prev );




void global_launch_method_pointwise_1a(const int Number_Iterations,int Einstein,const int Number_Points,const int K,const double ERR,const Complex Psi,const int Refined, const double refined_nb_iterations, const double print_coeff, Data_in & Data);

#endif


