/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller                                   *
 *   jkeller@imperial.ac.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "sort.h"
 
int partition(vector<Point> &X, int first, int last){
	int compteur,i; 
	double pivot;
        Point temp;
       
        compteur=first;
       
        pivot=X[first].mass;
        for(i=first+1;i<=last; i++ ){
		if(X[i].mass>pivot){
			compteur++;
			temp=X[compteur];
			X[compteur]=X[i];
			X[i]=temp;
		
		}
	}
	temp=X[compteur];
	X[compteur]=X[first];
	X[first]=temp;
        return(compteur);
} 


void tri_rapide_bis(vector<Point> &X, int first, int last){
    int pivot;
     if(first<last){
	pivot=partition(X,first,last);
	tri_rapide_bis(X,first,pivot-1);
	tri_rapide_bis(X,pivot+1,last);
     }

}
void quicksort(vector<Point> &X,int Nbpoints)
{
	tri_rapide_bis(X,0,Nbpoints-1);
}




