/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Sections.h"
#define Complex  std::complex<double>
#define pow2(x) (x*x)
#define pow3(x) (x*x*x)
#define pow4(x) pow2(x*x)

/*
#include <boost/thread/thread.hpp>
#include <boost/bind.hpp>

#include <boost/numeric/ublas/vector_proxy.hpp>
#include <boost/numeric/ublas/triangular.hpp>
#include <boost/numeric/ublas/lu.hpp>
*/
/*
static void sAlphaHalf(const u::vector<Point> &X, const vvectorI &Sec, int np, int st, MMatrix<Complex> *sA)
{           // computes the homogenous monomials for x_i's
   Complex p;
   int NS= (*sA).getWidth();
   int i,j,k;
   for(k=st; k<st+np; k++)
      for(i=0; i<NS; i++)
      {
         p=1.0;
         for(j=0; j<degree_polynomial_f(); j++) p *= pow(X(k).comp[j], Sec[i][j]);
         (*sA)[k][i]=p;
      }
}
*/
// //Given a bunch of sections (polynomials x_i^{a_i} and a point) we evaluate the sections at that point and return a vector of complex numbers.
/*void sAlpha_pointwise(const Point &X,const vector<vector<int> > &Sec,const int K,
                      Vector &Result)
    //here Result if a vector of complex of size the number of sections NS.
{
    int i,j;
    int NS=Sec.size();
    Matrix ValuePoints(degree_polynomial_f(),K+1);  //this is a very small thing around = 6*15*double. should be MMatrix

    for(i=0;i<degree_polynomial_f();i++)
    {
        ValuePoints(i,0)=1;
    }
    for(i=0;i<degree_polynomial_f();i++)
    {
        ValuePoints(i,1)=X.comp[i];
    }
    for(i=0;i<degree_polynomial_f();i++)
    {
        for(j=2;j<K+1;j++)
        {
            ValuePoints(i,j)=ValuePoints(i,j-1)*ValuePoints(i,1);
        }
    }
//   Vector Result(NS);  //around 150 to 1500*complex
    for(i=0;i<NS;i++)
    {
        Result[i]=1.0; //erase previous results
        for(j=0;j<degree_polynomial_f();j++)
        {
            Result[i]*=ValuePoints(j,Sec[i][j]);
        }
    }
   //return(Result);  //not sure it is the best way because creates 
}

*/


void sAlpha_pointwise2a(const int K,Data_in & Data,const Point &X)
{
  int i,j;
//  int deg=degree_polynomial_f();
  int deg = Degree +1;
 //   int NS=Sec.size();
    //MMatrix<Complex> ValuePoints(N,K+1);  //this is a very small thing around = 6*15*complex. should be MMatrix

    /*for(i=0;i<N;i++)
  {
  ValuePoints[i][0]=1;
}*/
  for(i=0;i<deg;i++)
  {
    Data.ValuePoints[i][1]=X.comp[i];
  }
  for(i=0;i<deg;i++)
  {
    for(j=2;j<K+1;j++)
    {
      Data.ValuePoints[i][j]=Data.ValuePoints[i][j-1]*Data.ValuePoints[i][1];
    }
  }
//   Vector Result(NS);  //around 150 to 1500*complex
  for(i=0;i<Data.Sec.size();i++)
  {
    Data.sApointwise2[i][0]=1.0; //erase previous results
    for(j=0;j<deg;j++)
    {
      Data.sApointwise2[i][0]*=Data.ValuePoints[j][Data.Sec[i][j]];
    }
  }
   //return(Result);  //not sure it is the best way because creates 
}
 
  


//the same function as before but for MMatrix type
/*void sAlpha_pointwise2(const Point &X,const vector<vector<int> > &Sec,const int K,
                       MMatrix<Complex> &Result,MMatrix<Complex> &ValuePoints)
    //here Result if a vector of complex of size the number of sections NS.
{
    int i,j;
 //   int NS=Sec.size();
    //MMatrix<Complex> ValuePoints(N,K+1);  //this is a very small thing around = 6*15*complex. should be MMatrix

    //for(i=0;i<N;i++)
    //{
    //    ValuePoints[i][0]=1;
    //}
    for(i=0;i<degree_polynomial_f();i++)
    {
        ValuePoints[i][1]=X.comp[i];
    }
    for(i=0;i<degree_polynomial_f();i++)
    {
        for(j=2;j<K+1;j++)
        {
            ValuePoints[i][j]=ValuePoints[i][j-1]*ValuePoints[i][1];
        }
    }
//   Vector Result(NS);  //around 150 to 1500*complex
    for(i=0;i<Sec.size();i++)
    {
        Result[i][0]=1.0; //erase previous results
        for(j=0;j<degree_polynomial_f();j++)
        {
            Result[i][0]*=ValuePoints[j][Sec[i][j]];
        }
    }
   //return(Result);  //not sure it is the best way because creates 
}
*/
/*
void sAlpha(const u::vector<Point> &X,MMatrix<Complex> &sA, const vvectorI &Sec)
{           // computes the homogenous monomials for x_i's
   int NS= sA.getWidth();
   using namespace boost;
   int np=X.size()/2;
   thread T(
      bind(&sAlphaHalf, ref(X),ref(Sec),np,0 , &sA) );
   sAlphaHalf (    X,     Sec,np, np, &sA)  ;
   T.join();
}
*/
//static !!!!!!!!!!!!!!!!!!!!!!!!!!!!!! \% remove this
/*
void sAlphaBeta(VVector<Complex> &sAB, const Vector &sA, const vvectorI &L)
{           // computes the sA * SB for non-trivi pairings
   vectorI v;

   for(uint i=0; i<L.size(); i++)
   {
      v=L[i];       // the square of the magnitude
      sAB[i]= (v[0]==v[1]) ? norm(sA(v[0])) : sA(v[0])*conj(sA(v[1]));
   }
}
*/
//Gives the bergman kernel term locally at the point induced for s_A
//which contains the result of the evaluation of the sections at this considered point.
//DsABpointwise must have been created before. Its size is number of blocks * double (in fact it is a vector)


double DsAlphaBeta_pointwise2a(Data_in & Data){
    
  MMatrix<Complex> temp(Data.Bs0.getHeight(),1);
  for(uint i=0; i<Data.Pairs.size(); i++)
  {
    Data.sABpointwise2[i][0]=(Data.Pairs[i][0]==Data.Pairs[i][1])?
        pow2(abs(Data.sApointwise2[Data.Pairs[i][0]][0])):         Data.sApointwise2[Data.Pairs[i][0]][0]*conj(Data.sApointwise2[Data.Pairs[i][1]][0]);
  }
  temp = average2(Data.sABpointwise2, Data.Bs0, Data.Bl0);
  Complex value=0;
  
  /*for(int j=0; j<Data.Bs0.size(); j++) {
        ///DsABpointwise(0,j) = double(BsL(j)) * temp(j);     
   value+= (Data.Bl0(j)<Data.sApointwise2.getHeight()) ?  ( double(Data.Bs(j)) * temp[j][0] * Data.vI_new2[j][0] ) : (2* (double (Data.Bs(j))) * temp[j][0] * Data.vI_new2[j][0]);
          
  }*/
  
  for(int j=Data.Bs0.size()-1; j>=0; j--) {
        
    value= Data.vI_new_horner[j][0]*(value +  ( (Data.Bl0[j]<Data.sApointwise2.getHeight()) ?  ( double(Data.Bs[j]) * temp[j][0]  ) : (2* (double (Data.Bs[j])) * temp[j][0]  )) );
  }
  return(real(value));
}


//the same function as before but with MMatrix lib.
/*
double DsAlphaBeta_pointwise2(const MMatrix<Complex> &sA,const VVector<int> &Bs, const VVector<int> &Bl, const VectorI &BsL,const vvectorI &L,const MMatrix<double>&vi,MMatrix<Complex> &sAB){
    
    MMatrix<Complex> temp(Bs.size(),1);
    for(uint i=0; i<L.size(); i++)
    {
        sAB[i][0]= sA[L[i][0]][0]*conj(sA[L[i][1]][0]);
    }
    temp = average2(sAB, Bs, Bl);
    Complex value=0;
    for(int j=0; j<Bs.size(); j++) {
        ///DsABpointwise(0,j) = double(BsL(j)) * temp(j);     
      value+= (Bl[j]<sA.getHeight()) ?  ( double(BsL(j)) * temp[j][0] * vi[j][0] ) : (2* (double (BsL(j))) * temp[j][0] * vi[j][0]);
          
    }
    return(real(value));
}
  */  
/*static void DsAlphaBetaHalf(const Vector &sA, Matrix *DsAB, const VectorI &Bs, const VectorI &Bl, const VectorI &BsL, const vvectorI &L, int Ls, int k)
{                 // the denominator of T
   int BS=(*DsAB).size2();
   VVector<Complex> v,t;
   v.resize(Ls,1); 
   t.resize(BS,1);
   sAlphaBeta(v,sA,L);
   t = average(v, Bs, Bl); // optimized here; next is full
   for(int j=0; j<BS; j++) (*DsAB)(k,j) = (double(BsL(j))) * t[j];
}

void DsAlphaBeta(const Matrix &sA, Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, const VectorI &BsL, const vvectorI &L)
{                 // the denominator of T
   int BS=DsAB.size2();
   using namespace boost;
   uint Ls=L.size();
   for(uint k=0; k<sA.size1(); k+=2)
   {
      /// should not do this, seems to open another thread!!!
      thread T(
         bind(&DsAlphaBetaHalf, ref(row(sA, k )),&DsAB, ref(Bs), ref(Bl), ref(BsL),ref(L), Ls,k) );
      DsAlphaBetaHalf(     row(sA, k+1),&DsAB,     Bs,      Bl,      BsL,     L,  Ls,k+1);
      T.join();
   }
}
*/

/*
static void oneIteration(const VectorD &vi, const sheaf &in, const VectorD &Mass, const Matrix &sA, const Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, const vvectorI &L, VectorD *f)
{
   int j, NAB=L.size();
   Vector v(NAB), vt(NAB);
   int NS= sA.size2();
   int BS=DsAB.size2();
   u::zero_vector<Complex> Zero(NAB); 
   ///v=Zero    DOes not compile assigment
   v.clear();           
   double p, t;

   for(int k=in.st; k<in.st+in.np; k++)  // if you do k+=2 and start from 0 resp 1
   {                         // then it's slightly slower!
      sAlphaBeta(vt, row(sA, k), L);
      p = 0;
      for(j=0; j<BS; j++) {t=real( DsAB(k,j)*vi(j) ); p += ( (Bl(j)<NS) ?  t : 2*t ); }
      v += ( Mass(k) / p ) * vt; // assert(imag(p)<1e-15);
   }
   (*f) = average(real(v), Bs,Bl);
}
*/
/*VectorD theBulk_pointwise(VectorD &vi, const int &NP, const int &NAB, const double &Mass, const Matrix &sA, const Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, int ns, const vvectorI &Pairs, const vvectorI &PairsL, const double &ERR, const VectorI &BsL, const VectorI &BlL, const vvectorI &L, int B, int K)
{
  int cnt=0;
  double err=1, g00;
  long double p1,p2;
  VectorD v2(BS);
  while(cnt<B && err>1e6*ERR/sqrt(NP))
  {
    oneIteration_pointwise(vi,in2??,Mass,sA,DsAB,Bs,Bl,L,&v2);
    G.clear();
    vectorToMatrix(v1+v2, G, PairsL, BsL,BlL);
    Invert<double>(G,Gi, ERR);
    v1 = vi; ///does not compile with just v1=vi
    MatrixToVector(vi, Gi, Pairs, Bs,Bl);
    g00 = 1/vi(0);
    vi *= g00; // /= NS not needed anymore

    err = norm_inf(vi-v1); // norm_inf = largest matrix element
    cnt++;
    cout << cnt <<": " << err << '\t';
  }
  cout << '\n';
  return vi;
  
}*/


/*
VVector<double> theBulk(VVector<double> &vi, const int &NP, const int &NAB, const VectorD &Mass, const Matrix &sA, const Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, int ns, const vvectorI &Pairs, const vvectorI &PairsL, const double &ERR, const VectorI &BsL, const VectorI &BlL, const vvectorI &L, int B, int K)
{
   int NS= sA.size2();
   int BS=DsAB.size2();
   using namespace boost;
   u::zero_matrix<double> Zero(NS,NS);
   u::zero_matrix<double> Zero(NS,NS);
   MMatrix<double> G(NS,NS), Gi(NS,NS); //, G1(NS,NS);
   VVector<double> v1,v2;
   v1.resize(BS,1), v2.resize(BS,1);
   int np = NP/2;
   sheaf in1(np,0), in2(np,np);
   int cnt=0;
   double err=1, g00;

   long double p1,p2;

   while(cnt<B && err>1e6*ERR/sqrt(NP))
   {
      //vectorToMatrix(vi, G1, PairsL, BsL,BlL);
      thread Tnew( bind(&oneIteration, ref(vi), in1,Mass,ref(sA),ref(DsAB),ref(Bs),ref(Bl),L, &v1) );
      oneIteration(     vi , in2,Mass,    sA ,    DsAB ,    Bs ,    Bl ,L, &v2);
      Tnew.join();

      //thread T1( bind(&Functional, ref(vi), in1,Mass,ref(DsAB),ref(Bs),ref(Bl), &p1, K) );
      Functional(     vi , in2,Mass,    DsAB ,    Bs ,    Bl , &p2, K,NS,BS)  ;
      //T1.join();
      //cout << "\nFunct: " << (p1 + p2) << '\n';

      ///  G=Zero; // Gi=Zero; Does not compile assigment
      //G.clear();
      
      vectorToMatrix(v1+v2, G, PairsL, BsL,BlL);
      Invert2(G,Gi, ERR);
      v1 = vi; ///does not compile with just v1=vi
      MatrixToVector(vi, Gi, Pairs, Bs,Bl);
      g00 = 1/vi[0];
      vi *= g00; // /= NS not needed anymore

      err = norm_inf(vi-v1); // norm_inf = largest matrix element
      cnt++;
      cout << "Cnt =" << cnt <<": " << err << " (error) "<< '\t';
      //the test G_new T(G) = id
      //double z=0; for(int i=0; i<NS; i++) for(int j=0; j<NS; j++) z += G1(i,j) * G(i,j);
      //z=abs(z/NS-1); if(z>1e-9) cout << "The error: "<< z <<"\n";
   }
   cout << '\n';
   return vi;
}
*/

/*
VectorD theBulkFunctional(VectorD &vi, const int &NP, const int &NAB, const VectorD &Mass, const Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, int ns, const vvectorI &Pairs, const vvectorI &PairsL, const double &ERR, const VectorI &BsL, const VectorI &BlL, const vvectorI &L, int B, int K)
{
  using namespace boost;
  double p1,p2, t;
  int np = NP/2;
  sheaf in1(np,0), in2(np,np);
  int cnt=0;
  double err=1, g00;
 
  while(cnt<B && err>1e6*ERR/sqrt(NP))
{
    //vectorToMatrix(vi, G1, PairsL, BsL,BlL);
    thread T( bind(&Functional, ref(vi), in1,Mass,ref(DsAB),ref(Bs),ref(Bl), &p1, K) );
                    Functional(     vi , in2,Mass,    DsAB ,    Bs ,    Bl , &p2, K)  ;
    T.join();
 
    cnt++;
    cout << cnt <<": " << err << '\t';
}
  cout << '\n';
  return vi;
}
*/



/*
static void Functional(const VectorD &vi, const sheaf &in, const VectorD &Mass, const Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, long double *f, int K,int NS,int BS)
{
   int j;
   long double p, t, s=1.0, oBS;
   double MassT=0;

   for(int k=in.st; k<in.st+in.np; k++)
   {
      p = 0;
      oBS = 0;
      for(j=0; j<BS; j++)
      {
         t=real( DsAB(k,j)*vi(j) ); p += ( (Bl(j)<NS) ?  t : 2*t );
         t=real( DsAB(k,j)); oBS += ( (Bl(j)<NS) ?  t : 2*t );
      }
      s += log(p / oBS) * Mass(k);
      MassT += Mass(k);
      //
      //if(k%100==0) cout << "Funct00: " << oBS / real(DsAB(k,0))<<"  "<<p / oBS<< '\n';
   }
   (*f) = (s)/MassT;
}

*/

