/***************************************************************************
 *   Copyright (C) 2007 by Julien Keller   *
 *   j.keller@imperial.ac.uk   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SECTIONS
#define SECTIONS

#include "in-output.h"
#include "iPoint.h"
#include <vector>
#include "GenericFunctions.h"
#include "Group.h"
#include "Symmetries.h"
#include "methods.h"

//#include <boost/thread/thread.hpp>
//#include <boost/bind.hpp>
//#include <boost/numeric/ublas/vector_proxy.hpp>
//#include <boost/numeric/ublas/triangular.hpp>
//#include <boost/numeric/ublas/lu.hpp>


/*
VVector<double> theBulk(VVector<double> &vi, const int &NP, const int &NAB, const VectorD &Mass, const Matrix &sA, const Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, int ns, const vvectorI &Pairs, const vvectorI &PairsL, const double &ERR, const VectorI &BsL, const VectorI &BlL, const vvectorI &L, int B, int K);
*/


//static void oneIteration(const VectorD &vi, const sheaf &in, const VectorD &Mass, const Matrix &sA, const Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, const vvectorI &L, VectorD *f);
//void sAlpha(const vector<Point> &X, MMatrix<Complex> &sA, const vvectorI &Sec);
//static void sAlphaHalf(const u::vector<Point> &X, const vvectorI &Sec, int np, int st, MMatrix<Complex> *sA);
//void DsAlphaBeta(const Matrix &sA, Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, const VectorI &BsL, const vvectorI &L);
//static void DsAlphaBetaHalf(const Vector &sA, Matrix *DsAB, const VectorI &Bs, const VectorI &Bl, const VectorI &BsL, const vvectorI &L, int Ls, int k);
//static void Functional(const VectorD &vi, const sheaf &in, const VectorD &Mass, const Matrix &DsAB, const VectorI &Bs, const VectorI &Bl, long double *f, int K,int NS,int BS);
//void sAlphaBeta(VVector<Complex> &sAB, const Vector &sA, const vvectorI &L);

//TODO modify this Invert.

/*
template<class T> void Invert(const u::matrix<T> &G, u::matrix<T> &Gi, double ERR)
{
    using namespace u;
    matrix<T> A(G); 		// working copy of the input
    permutation_matrix<std::size_t> P(A.size1()); // a permutation matrix for the LU-factorization
    lu_factorize(A,P);  	 	// LU-factorization
    u::identity_matrix<T> Id(A.size1());
    Gi.clear();
    for(int i0=0;i0<A.size1();i0++){
        Gi(i0,i0)=1;
    }
    ///Gi = Id; does not compile
    lu_substitute(A, P, Gi);  	// backsubstitute to get the inverse
    A = Gi + herm(Gi);
    //
    double x = norm_inf(Gi - herm(Gi)); if(x>ERR) cout<<"Inversion H: "<< x <<'\n';
    Gi = (1.0/2) * A;
    //
    A = prod(Gi, G) - Id; x=norm_inf(A); if(x>ERR) cout<<"Inversion !: "<< x <<'\n'; // test for error
}
*/
//ADDED to do pointwise operations.
//void sAlpha_pointwise(const Point &X,const vector<vector<int> > &Sec,const int K,
//                      VVector<Complex> &Result);
                      
//void sAlpha_pointwise2(const Point &X,const vector<vector<int> > &Sec,const int K,
//                       MMatrix<Complex> &Result,MMatrix<Complex> &ValuePoints);
void sAlpha_pointwise2a(const int K,Data_in & Data,const Point &X);
                       

double DsAlphaBeta_pointwise2a(Data_in & Data);
            
#endif
